from brainlab import *
# TODO: figure out why exception occurs if you don't remove
# tj* on local and remote (bug in LoadSpikeData?)

# build the model
brain=BRAIN()
c1=brain.Standard1CellColumn()
c2=brain.Standard1CellColumn()
brain.AddConnect(c1, c2, prob=1.0)

# apply stimulus, request report
stim=[x/100.0 for x in range(0, 10)]
print stim
brain.AddSpikeStim(c1, stim)
rep=brain.AddSimpleReport('test', c2, 'v', dur=(0, .3))

px=[]
py=[]
for maxcond in [(mc/10.0) for mc in range(0, 10)]: 
    # change the conductivity on the synapse being used
    syn=brain.syntypes['C.strong']
    syn.parms['MAX_CONDUCT']=maxcond

    # run the sim
    brain.Run(parms={'DURATION': .3, 'JOB': 'tj%f'%maxcond})

    # analyze the results
    res=LoadSpikeData(brain, rep)
    print "maxcond %f, spikes on cell 0: %d" %(maxcond, len(res[0]))
    px.append(maxcond)
    py.append(len(res[0]))

print px, py
import matplotlib
figure(1)
plot(px, py)
show()
