#!/usr/bin/env python

import wang99_Ne_Ni
from sys import exit
import threading, time, random

real=False      # if False don't actually Run(), just wait in thread

def DoExp(pn, jobparms):
    """ this is invoked in each thread """
    ee, ei, ie=jobparms
    print 'doing exp for %d %d %d' % (ee, ei, ie)
    jobname = 'wang99_Ne_Ni_.%d.%d.%d' % (ee, ei, ie)
    #b.parms['JOB'] = jobname
    c_ee = '%.10f   0' % (ee*1e-10)
    c_ei = '%.10f   0' % (ei*1e-10)
    c_ie = '%.10f   0' % (ie*1e-10)
    #wang99_Ne_Ni.SetMaxConduct(c_ee, c_ei, c_ie)
    b = wang99_Ne_Ni.MakeModel(jobname, c_ee, c_ei, c_ie)
    if real:
        res = b.Run(verbose = False, nprocs = 1, procnum=pn)
    else:
        # fake a real run
        time.sleep(random.randrange(0, 2))
        res=True
    if res:
        print "...Job appeared to have run OK"

# main program starts here:

joblist=[]
# create a list of all job params we need to run:
for iek in range(4, 11):
    ie = 5*iek
    for ee in range(0, 11):
        for ei in range(0, 11):
            joblist.append((ee, ei, ie))    # (,,) is a tuple

# how many threads we want to try to run in parallel
# your mach file better have this many machines listed!
numjobs=20

thl={}      # table of running threads
# get things started:
for j in range(1, numjobs+1):
    jobparms=joblist.pop()
    print "starting jobparms", jobparms
    thist=threading.Thread(target=DoExp, args=(j, jobparms))
    thl[j]=thist
    thist.start()

#print 'Running %s with max conducts ee=%s, ei=%s, ie=%s...' % (jobname, c_ee, c_ei, c_ie)
while len(joblist) > 0:
    print "%d jobs remaining" % len(joblist)
    nl=threading.enumerate()
    print "%d threads running" % (len(nl) - 1)    # -1: don't count main thread
    for j in range(1, numjobs+1):
        if thl[j] not in nl:        # thread done
            #print "job %d finished" % j
            # start a new one on the same processor:
            if len(joblist) > 0:
                jobparms=joblist.pop()
                #print "starting jobparms", jobparms
                thist=threading.Thread(target=DoExp, args=(j, jobparms))
                thl[j]=thist
                thist.start()
        else:
            #print "job %d running" % j
            pass
    time.sleep(1)

#all jobs have been started, make sure all have finished:
nl=threading.enumerate()
while len(nl) > 1:
    print "waiting for last jobs to finish"
    time.sleep(1)
    nl=threading.enumerate()

print "all done"
